<?php
namespace Zeedhi\PaymentPlatform\DebitBuy;

use Zeedhi\PaymentPlatform\Transaction;
use Zeedhi\PaymentPlatform\CreditCard;
use Zeedhi\PaymentPlatform\Customer;

class DebitBuyTransaction extends Transaction {

    /** @var CreditCard */
    private $creditCard;
    /** @var Customer */
    private $customer;
    
    /**
     * @param float         $value
     * @param string        $transactionId
     * @param CreditCard    $creditCard
     * @param Customer      $customer
     */
    public function __construct($value, $transactionId, CreditCard $creditCard, Customer $customer, $nrInstallment = 1) {
        parent::__construct($value, $transactionId, $nrInstallment);
        $this->creditCard = $creditCard;
        $this->customer = $customer;
    }

    /**
     * @return CreditCard
     */
    public function getCreditCard() {
        return $this->creditCard;
    }
    
    /**
     * @return Customer
     */
    public function getCustomer() {
        return $this->customer;
    }

    public function setItems($items) {
        $this->items = $items;
    }

    /**
     * @return Items
     */
    public function getItems() {
        return $this->items;
    }

    public function setAuthentication($Authentication) {
        $this->Authentication = $Authentication;
    }

    /**
     * @return Authentication
     */
    public function getAuthentication() {
        return $this->Authentication;
    }

    public function setReturnUrl($ReturnUrl) {
        $this->ReturnUrl = $ReturnUrl;
    }

    /**
     * @return ReturnUrl
     */
    public function getReturnUrl() {
        return $this->ReturnUrl;
    }

    public function setTransactionType($TransactionType) {
        $this->TransactionType = $TransactionType;
    }

    /**
     * @return TransactionType
     */
    public function getTransactionType() {
        return $this->TransactionType;
    }

    public function setCredentialsCode($CredentialsCode) {
        $this->CredentialsCode = $CredentialsCode;
    }

    /**
     * @return CredentialsCode
     */
    public function getCredentialsCode() {
        return $this->CredentialsCode;
    }

    public function setCredentialsKey($CredentialsKey) {
        $this->CredentialsKey = $CredentialsKey;
    }

    /**
     * @return CredentialsKey
     */
    public function getCredentialsKey() {
        return $this->CredentialsKey;
    }

    public function setProvider($Provider) {
        $this->Provider = $Provider;
    }

    /**
     * @return Provider
     */
    public function getProvider() {
        return $this->Provider;
    }

}