<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\Cielo\PaymentImpl;
$paymentPlatform = PaymentImpl::factory(
    "FFXPQEDSNSWPQCMWBYSEXSEAVOMGDJOMWQKGRQPL",
    "67466780-45be-4cb7-b72f-7529c520d146",
    PaymentImpl::SANDBOX
 );

use Zeedhi\PaymentPlatform\InstantBuy\InstantBuyPlatform;
use Zeedhi\PaymentPlatform\InstantBuy\InstantBuyTransaction;

use Zeedhi\PaymentPlatform\Address;
use Zeedhi\PaymentPlatform\Customer;
use Zeedhi\PaymentPlatform\CreditCard;

class Order {

    private $paymentPlatform;

    public function __construct(InstantBuyPlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }

    public function createInstantBuy($creditCard, $customer) {
        return $this->paymentPlatform->createToken($creditCard, $customer);
    }

    public function createOrder($value, $transactionId, $flag, $instantBuy, $customer) {
        $transaction = new InstantBuyTransaction($value, $transactionId, $instantBuy, $customer);
        $transaction->setFlag($flag);
        $nit = $this->paymentPlatform->instantBuyTransaction($transaction);
        var_dump($nit);
        $order = $this->paymentPlatform->captureTransaction($nit['captureUrl'], $nit['paymentId']);
        var_dump($order);
    }
}

$customer = new Customer();
$customer->setName("Stephen Vincent Strange");

$holderName = "Stephen Vincent Strange";
$numbers = "1";
$expDateMonth = "12";
$expDateYear = "2018";
$cvv = "123";
$flag = "Visa";
$creditCard = new CreditCard($holderName, $numbers, $expDateMonth, $expDateYear, $cvv, $flag);

$order = new Order($paymentPlatform);

$token = $order->createInstantBuy($creditCard, $customer);

var_dump($token);

$value = ceil("15.00" * 100);
$transactionId = "0666";

$finalOrder = $order->createOrder($value, $transactionId, $creditCard->getFlag(), $token['InstantBuyKey'], $customer);
