var ZeedhiDirectives = angular.module("ZeedhiDirectives");

ZeedhiDirectives.directive('zhMonthPicker', function() {
	return {
		restrict: 'A',
		link: function($scope, element) {
			var separator = $scope.widget.separator || "/";
			var controlFormat = "MM" + separator + "YYYY";
			
			var widget = $scope.widget;
			var dateFormat = widget.dateFormat || controlFormat;
			var monthNames = widget.monthNames || moment.months();
			var shortMonthNames = widget.shortMonthNames || moment.monthsShort();
			$scope.monthRows = [];
			
			$scope.currentYear = widget.currentYear || moment().get('year');
			var monthRow = [];

			function isMonthBlocked(start, end, date, dateFormat){
				if(start && end){
					return !Util.isBetweenDate(start, end, date, dateFormat);
				} else if(start && !end){
					return !Util.isDateGte(date, start, dateFormat);
				} else if(!start && end){
					return !Util.isDateLte(date, end, dateFormat);
				} else {
					return false;
				}
			}

			function getMonthDate(month) {
				return month + separator + $scope.currentYear;
			}

			for (var i = 0; i < 12; i++) {
				var monthDate = getMonthDate(i + 1);
				
				monthRow.push({
					number: i + 1,
					value: monthDate,
					name: widget.fullNames ? monthNames[i] : shortMonthNames[i],
					blocked: isMonthBlocked(widget.minDate, widget.maxDate, moment(monthDate, controlFormat).format(dateFormat), dateFormat)
				});

				if (monthRow.length === 4) {
					$scope.monthRows.push({
						months: monthRow
					});
					monthRow = [];
				}
			}

			$scope.navigateDate = function(value) {
				$scope.currentYear += value;
				$scope.monthRows.forEach(function(data) {
					data.months.forEach(function(month) {
						month.blocked = isMonthBlocked(widget.minDate, widget.maxDate, moment(getMonthDate(month.number), controlFormat).format(dateFormat), dateFormat);
					});
				});
			};

			$scope.monthClick = function(month) {
				if (widget.monthClick) {
					widget.monthClick();
				}

				widget.currentYear = $scope.currentYear;

 				if (!isMonthBlocked(widget.minDate, widget.maxDate, moment(getMonthDate(month.number), controlFormat).format(dateFormat), dateFormat)) {
					month = month.number.toString();
					if (month.length === 1) {
						month = "0" + month;
					}

					$scope.widget.setCurrentRow(moment(getMonthDate(month), controlFormat).format(dateFormat));
				}
			};
		}
	};
});