function VisualizationsWidgetsCreator(metaDataFactory, ScreenService) {

	this.createPopupVisualizations = function(gridWidget, functionsToInject) {
		var widget = metaDataFactory.widgetFactory({
			"id": 1,
			"isVisible": true,
			"showAsModal": true,
			"template": "widget/grid.html",
			"name": "popUpVisualizationsList",
			"label": ScreenService.i18n("Views"),
			"container": gridWidget.container,
			"showCheckbox":true,
			"floatingControl": {
				"refreshAction": false,
				"customizationAction": {
					"layout": false,
					"filter": false,
					"view": false
				},
				"actions": []
			},
			"actions": actionsPreferencesWidget,
			"events": [
				{
					"id": 2,
					"name": "WidgetOnEnter",
					"code": "args.owner.visualizationsListOnEnter(args.owner);"
				},
				{
					"id": 3,
					"name": "WidgetAfterMoveRow",
					"code": "args.owner.openFormEditVisualization(args.owner, args.row);"
				}
			],
			"dataSource": {
				"data": [],
				"localStorage": false,
				"rest": false
			},
			"fields": [
				{
					"id": 1,
					"name": "label",
					"label": ScreenService.i18n("View name"),
					"showOnList": true,
					"template": "field/text-edit.html"
				},
				{
					"id": 2,
					"name": "viewRepositoryLabel",
					"label": ScreenService.i18n("Type"),
					"showOnList": true,
					"template": "field/text-edit.html"
				}
			]
		});
		return Util.extend(widget, functionsToInject);
	};

	var actionsPreferencesWidget = [
		{
			"id": 2,
			"name": "newVisualization",
			"isVisible": true,
			"showAsAction": "always",
			"icon": "plus icon-white",
			"tooltip": ScreenService.i18n("New"),
			"events": [{
				"id": 1,
				"name": "ActionEvent",
				"code": "args.owner.widget.openFormNewVisualization()"
			}]
		},
		{
			"id": 3,
			"name": "cancelAction",
			"label": ScreenService.i18n("Close"),
			"showAsAction": "back",
			"hideIcon": true,
			"isVisible": true,
			"events": [{
				"id": 1,
				"name": "ActionEvent",
				"code": "ScreenService.closePopup(); ScreenService.updateTemplate();"
			}]
		},
		{
			"id": 4,
			"name": "deleteVisualization",
			"isVisible": true,
			"icon": "trash",
			"showAsAction": "checked_rows",
			"tooltip": ScreenService.i18n("Delete view"),
			"events": [
				{
					"id": 1,
					"name": "ActionEvent",
					"code": "args.owner.widget.deleteVisualizations(args.owner.widget);"
				}
			]
		}
	];

	this.createPopupViewCreator= function(gridWidget, functionsToInject, listViewsWidget){
		var widget =  metaDataFactory.widgetFactory({
			"id": 1414,
			"name": "view_creator",
			"container": gridWidget.container,
			"parentWidget" : listViewsWidget,
			"label": ScreenService.i18n("View"),
			"template": "widget/form-login.html",
			"isVisible": true,
			"showAsModal": true,
			"fields": [
				{
					"id": "dasgdv12",
					"name": "label",
					"label": ScreenService.i18n("View Name"),
					"template": "field/text-edit.html",
					"showOnList": true,
					"validations": {
						"required":{
							"message": ScreenService.i18n("Required Field")
						}
					}
				},
				{
					"name": "customizationRepository",
					"label": ScreenService.i18n("View Type"),
					"class": "12",
					"isVisible": true,
					"showOnList": true,
					"showOnForm": true,
					"showOnView": true,
					"template": "field/select-native.html",
					"valueField": "value",
					"descriptionField": "label",
					"events": [{
						"name": "FieldOnChange",
						"code": "args.owner.field.widget.onSelectRepository(args.owner.field.widget, args.owner.field)"
					}],
					"hideEmptyValue": false,
					"dataSource": {
						"data":[]
					},
					"validations": {
						"required":{
							"message": ScreenService.i18n("Required Field")
						}
					}
				},
				{
					"name": "viewPreference",
					"label": ScreenService.i18n("Layout Preference"),
					"class": "12",
					"isVisible": true,
					"showOnList": true,
					"showOnForm": true,
					"showOnView": true,
					"readOnly": true,
					"template": "field/select-native.html",
					"valueField": "_id",
					"descriptionField": "label",
					"events": [],
					"hideEmptyValue": false,
					"dataSource": {
						"data":[]
					},
					"validations": {
						"required":{
							"message": ScreenService.i18n("Required Field")
						}
					}
				},
				{
					"name": "viewFilter",
					"label": ScreenService.i18n("Filter"),
					"class": "12",
					"isVisible": true,
					"showOnList": true,
					"showOnForm": true,
					"readOnly": true,
					"showOnView": true,
					"template": "field/select-native.html",
					"valueField": "_id",
					"descriptionField": "label",
					"events": [],
					"hideEmptyValue": false,
					"dataSource": {
						"data":[]
					},
					"validations": {
						"required":{
							"message": ScreenService.i18n("Required Field")
						}
					}
				}
			],
			"dataSource": [],
			"events": [],
			"actions": [
				{
					"id": 2,
					"name": "cancelAction",
					"label": ScreenService.i18n("Cancel"),
					"showAsAction": "back",
					"hideIcon": true,
					"isVisible": true,
					"events": [{
						"id": 1,
						"name": "ActionEvent",
						"code": "ScreenService.closePopup();"
					}]
				},
				{
					"id": 2,
					"name": "saveAction",
					"label": ScreenService.i18n("Save & Apply"),
					"showAsAction": "never",
					"hideIcon": true,
					"isVisible": true,
					"events": [{
						"id": 1,
						"name": "ActionEvent",
						"code": "args.owner.widget.save(args.owner.widget)"
					}]
				}
			]
		});
		return Util.extend(widget, functionsToInject);
	};

	this.createChangePreferenceTypeWidget = function(gridWidget, functionsToInject, parentWidget){
		var widget = metaDataFactory.widgetFactory({
			"id": 8998,
			"name": "changePreferenceTypeWidget",
			"showAsModal": true,
			"container": gridWidget.container,
			"parentWidget": parentWidget,
			"label": ScreenService.i18n("Change view type"),
			"template": "widget/form.html",
			"showDescriptionOrder": false,
			"isVisible": true,
			"fields": [
				{
					"name": "preferenceType",
					"label": ScreenService.i18n("New view type"),
					"class": "12",
					"isVisible": true,
					"readOnly": false,
					"showOnList": true,
					"showOnForm": true,
					"showOnView": true,
					"template": "field/select-native.html",
					"valueField": "value",
					"descriptionField": "label",
					"events": [],
					"hideEmptyValue": false,
					"dataSource": {
						"data":[]
					},
					"validations": {
						"required":{
							"message": ScreenService.i18n("Required Field")
						}
					}
				}
			],
			"events": [],
			"actions":[
				{
					"id": 1,
					"name": "canceladd",
					"label": ScreenService.i18n("Cancel"),
					"isVisible": true,
					"hideIcon": true,
					"showAsAction": "back",
					"events": [{
						"id": 1,
						"name": "ActionEvent",
						"code": "ScreenService.closePopup(); ScreenService.updateTemplate();"
					}]
				},
				{
					"id": 1,
					"name": "addPreference",
					"label": ScreenService.i18n("Save"),
					"isVisible": true,
					"showAsAction": "never",
					"events": [
						{
							"id": 1,
							"name": "ActionEvent",
							"code": "args.owner.widget.saveTransferLayoutClick(args.owner.widget)"
						}
					]
				}
			]
		});
		return Util.extend(widget, functionsToInject);
	};

}

Configuration(function(ContextRegister) {
	ContextRegister.register("visualizationsWidgetsCreator", VisualizationsWidgetsCreator);
});
