function ProfileController(ApplicationContext, ConsumerRepository, LoginController, ConsumersRepository, BalanceRepository, Utilities, ScreenService, templateManager, ProfileService, LoginRepository, ConsumerDetailsRepository, CitiesRepository, NeighbourhoodsRepository, Query, LayoutRepo, ZHPromise, BalanceService, SpeakToUsService){

    var self = this;

    var EnableOff = ['restrictAliment'];

    this.setCurrentGoldFamilies = function (container){
        LoginRepository.findOne().then(function (consumerData) {
            var promises = [];
            promises.push(BalanceService.getBalance(consumerData.CDCLIENTE, consumerData.CDCONSUMIDOR, consumerData.CDFILIAL));
            ZHPromise.all(promises).then(function(data) {
                var balanceData = data[0];
                var totalBalance = {
                    NMFAMILISALD: 'TOTAL',
                    VRSALDCONFAM: 0
                };

                balanceData.forEach(function(currentBalance) {
                    //currentBalance.NMFAMILISALD = currentBalance.NMFAMILISALD.namefy();
                    totalBalance.VRSALDCONFAM += parseFloat(currentBalance.VRSALDCONFAM.replace(',','.'));
                });
                totalBalance.VRSALDCONFAM = totalBalance.VRSALDCONFAM.toFixed(2).replace('.',',');
                balanceData.push(totalBalance);
                container.getWidget('currentGold').dataSource.data = balanceData;
            });
        });
    };

    /* Gets the consumer's details and updates the fields. */
    this.getConsumerDetails = function(container){
        var dadospessoaisWidget = container.widgets[0];
        var enderecoWidget = container.widgets[1];

        // for some unknown reason, Zeedhi triggers WidgetOnEnter when you "WidgetOnEnterTab" if the form is in edit mode
        if ((dadospessoaisWidget.mode != 'edit') && (enderecoWidget.mode != 'edit')) {
            dadospessoaisWidget.dataSource.data = [];
            enderecoWidget.dataSource.data = [];
            ConsumerRepository.findOne().then(function (consumerData){
                ProfileService.getConsumerDetails(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], consumerData['CDFILIAL']).then(function (consumerDetails){

                    /*personal details tab*/
                    dadospessoaisWidget.dataSource.data = consumerDetails;
                    if (dadospessoaisWidget.dataSource.data[0].HABENVNOTIF === 'S'){
                        dadospessoaisWidget.dataSource.data[0].habNotif = 'Y';
                    } else{
                        dadospessoaisWidget.dataSource.data[0].habNotif = 'N';
                    }
                    if (dadospessoaisWidget.dataSource.data[0].HABENVEMAIL === 'S'){
                        dadospessoaisWidget.dataSource.data[0].habEmail = 'Y';
                        templateManager.container.getWidget('dadospessoais').getField('lbNotifsald').isVisible = true;
                    } else{
                        dadospessoaisWidget.dataSource.data[0].habEmail = 'N';
                        templateManager.container.getWidget('dadospessoais').getField('lbNotifsald').isVisible = false;
                    }
                    dadospessoaisWidget.moveToFirst();
                    dadospessoaisWidget.setCurrentRow(dadospessoaisWidget.dataSource.data[0]);

                    /*address tab*/
                    enderecoWidget.dataSource.data = consumerDetails;
                    enderecoWidget.moveToFirst();
                    enderecoWidget.setCurrentRow(enderecoWidget.dataSource.data[0]);

                    self.showHideSonsField(dadospessoaisWidget, dadospessoaisWidget.getField('habEmail'));

                    templateManager.updateTemplate();
                });
            });
        }
    };
    
    this.askProfileDeletion = function(widget) {
        let subject = 'Exclusão de Perfil';
        let body = 'Exclusão de perfil requerida.';
        
        ScreenService.confirmMessage(
            'Realmente deseja solicitar a exclusão do perfil?',
            'question',
            function(){
                SpeakToUsService.submitForm( subject, widget.currentRow.DSEMAILCONS, widget.currentRow.NRCELULARCONS, body , widget.currentRow.CDCLIENTE , widget.currentRow.CDCONSUMIDOR, Utilities.appUrl, Utilities.logoEmpresa).then(function (){
                    ScreenService.showMessage('A exclusão do perfil será processada pela Instituição! <br> O retorno será atráves do email ou telefone cadastrado.');
                    ScreenService.openWindow('parentDashboard');
                });
              
            },
            function(){}
        );
        
    }

    this.openEditAdress = function() {
        var dadospessoaisWidget = templateManager.container.getWidget('dadospessoais');
        var enderecoWidget = templateManager.container.getWidget('endereco');

        var widgets = [dadospessoaisWidget, enderecoWidget];

        widgets.forEach(function(widget){
            // Configure actions visibility
            widget.getAction('voltar').isVisible = false;
            widget.getAction('salvar').isVisible = true;

            widget.oldRow = Util.clone(widget.currentRow);
            widget.edit();
            widget.template = widget.formTemplate;
        });

        ScreenService.updateTemplate();
    };

    this.cancelEdit = function() {
        var openEdit = ProfileService.getOpenEdit();
        if(openEdit){
            ScreenService.showMessage("É necessário completar os dados de cadastro antes de utilizar o aplicativo!");
        } else{
            var dadospessoaisWidget = templateManager.container.getWidget('dadospessoais');
            var enderecoWidget = templateManager.container.getWidget('endereco');

            var widgets = [dadospessoaisWidget, enderecoWidget];

            widgets.forEach(function(widget){
                widget.currentRow = Util.clone(widget.oldRow);
                // Configure actions visibility
                widget.getAction('voltar').isVisible = true;
                widget.getAction('salvar').isVisible = false;

                widget.template = 'widget/form-view.html';
                widget.view();
            });
        }
    };

    /* Determines which fields in each tab will be validated. */
    this.buildArrayFieldsForValidation = function(){
        var dados = [
            'NMRESPCONS',
            'DSEMAILCONS',
            'NRCPFRESPCON',
            'NRCELULARCONS'
        ];

        var endereco = [
            'DSENDECONS',
            'NRENDECONS',
            'NRCEPCONS',
            'SGESTADO',
            'NMMUNICIPIO'
        ];

        return {
            dados: dados,
            endereco: endereco
        };
    };

    /* Validates the required fields in a tab to see if they are empty. */
    this.checkRequireFieldsByTab = function(tabWidget, fields, masterWidget){
        var row = masterWidget.currentRow;
        var OK = true;

        fields.forEach(function(field){
            if (!row[field]) {
                OK = false;
                masterWidget.currentRow.$error[field] = [{"message" : "obrigatório", "class": "field-require"}];
            }
        });

        if (!OK){
            if (!tabWidget.label.endsWith("*")){
                /* Adds a flag to the tab label. */
                tabWidget.label += "*";
            }
        }
        else if (tabWidget.label.endsWith("*")){
            /* Removes the flag to the tab label. */
            tabWidget.label = tabWidget.label.removeLastChar();
        }

        return OK;
    }

    this.checkWidgetEnableOff = function(nameWidget){
        EnableOff.map(function(name){
            if(name == nameWidget){
                return true;
            }
        });
    };

    /* Validation. */
    this.checkDetails = function(container) {
        details = container.widgets[0].dataSource.data[0];

        container.widgets[0].currentRow.$error = {};

        var dadospessoaisWidget = templateManager.container.getWidget('dadospessoais');
        var enderecoWidget = templateManager.container.getWidget('endereco');
        var widgets = [dadospessoaisWidget, enderecoWidget];

        var tabDadosOK = this.checkRequireFieldsByTab(container.widgets[0], this.buildArrayFieldsForValidation().dados, container.widgets[0]);
        var tabEnderecoOK = this.checkRequireFieldsByTab(container.widgets[1], this.buildArrayFieldsForValidation().endereco, container.widgets[0]);

        if (!tabDadosOK || !tabEnderecoOK){
            ScreenService.showMessage('Existem campos obrigatórios não preenchidos.');
        }
        else if (!ApplicationContext.LoginController.isValidEmail(details['DSEMAILCONS'])){
            ScreenService.showMessage('Email inválido.');
        }
        else {
            dadospessoaisWidget.getField('NRCPFRESPCON').readOnly = true;
            if(ProfileService.getOpenEdit()){
                if(Utilities.isValidCPF(dadospessoaisWidget.getField('NRCPFRESPCON').value())){
                    this.saveConsumerDetails(container, true);
                    ProfileService.setOpenEdit(false);   
                } else{
                    ScreenService.showMessage('CPF inválido');
                    dadospessoaisWidget.getField('NRCPFRESPCON').readOnly = false;
                    templateManager.updateTemplate();
                }
            } else{
                this.saveConsumerDetails(container);
                templateManager.updateTemplate();
            }
        }
    };

    /* Saves the edited consumer details. */
    this.saveConsumerDetails = function(container, openEdit = false){
        var consumerData = container.widgets[0].dataSource.data[0];
        if (consumerData.IDSEXOCONS == null) {
            consumerData.IDSEXOCONS = "";
        }
        consumerData.IDSEXOCONS = consumerData.IDSEXOCONS.substring(0,1);
        // CPF is no longer editable
        consumerData.NRCPFRESPCON = consumerData.NRCPFRESPCON.replace('.','').replace('.','').replace('-','');
        if (consumerData['CDPAIS'] == null) {
            consumerData['CDPAIS'] = '0055';
        }

        /* Remove the mask before insert phones into database */
        if(consumerData.NRTELECONS){
            consumerData.NRTELECONS = Utilities.removeMaskFromTelephone(consumerData.NRTELECONS);
        }
        if (consumerData.NRCELULARCONS) {
            consumerData.NRCELULARCONS = Utilities.removeMaskFromTelephone(consumerData.NRCELULARCONS);
        }

        if(consumerData.habNotif === 'Y'){
            consumerData.HABENVNOTIF = 'S';
        } else{
            consumerData.HABENVNOTIF = 'N'
        }

        if(consumerData.habEmail === 'Y'){
            consumerData.HABENVEMAIL = 'S';
        } else{
            consumerData.HABENVEMAIL = 'N'
        }
        
        LoginRepository.findOne().then(function (previousConsumerData){
            //Setting current CDFILIAL so that recharge grid screen works perfectly
            consumerData['CDFILIAL'] = previousConsumerData['CDFILIAL'];
            ProfileService.saveConsumerDetails(consumerData, openEdit).then(function (returnData){
                /* Validation. */
                if (returnData['error'] == null){
                    //this.resetForms(container);
                        LoginRepository.save(consumerData).then(function(){
                            LoginController.changeUserMenu(consumerData);
                            if(openEdit === false){
                                ScreenService.openWindow('profile');
                            }
                            ScreenService.showMessage('Dados atualizados com sucesso.');
                        });
                } else {
                    ScreenService.showMessage(returnData['error']);
                }
    
                container.widgets.forEach(function(widget){
                    // Configure actions visibility
                    widget.getAction('salvar').isVisible = false;
                    widget.getAction('voltar').isVisible = true;
    
                    // After saving set the currentWidget to view mode
                    widget.view();
                    widget.template = widget.formTemplate;
                });
    
                ScreenService.updateTemplate();
            }.bind(this));
        });
    };

    /* Limits the date to prevent a future birthdate from being chosen. */
    this.setDateLimit = function(datePicker){
        var currentDate = new Date();
        datePicker.field['datetime-maxDate'] = currentDate.getFullYear() + '-' + currentDate.getMonth() + '-' + currentDate.getDate();
    };

    /* CPF validation. */
    this.isValidCPF = function(cpf){
        cpf = cpf.replace('.','').replace('.','').replace('-','');
        var total;
        var first, second;

        total = 0;
        for (i = 1; i <= 9; i++){
            total += parseInt(cpf.substring(i-1, i)) * (11 - i);
        }
        first = (total * 10) % 11;
        if (first == 10 || first == 11)    first = 0;

        total = 0;
        for (i = 1; i <= 10; i++){
            total+= parseInt(cpf.substring(i-1, i)) * (12 - i);
        }
        second = (total * 10) % 11;

        if ((second == 10) || (second == 11)) second = 0;
        return !(first != parseInt(cpf.substring(9, 10)) || second != parseInt(cpf.substring(10, 11)))
    };

    /* Resets the forms, changing them back to read-only mode. */
    this.resetForms = function(container){
        container.widgets[0].template = "widget/form-view.html";
        container.widgets[0].actions[1].isVisible = true;
        container.widgets[0].actions[2].isVisible = false;
        container.widgets[1].template = "widget/form-view.html";
        container.widgets[1].actions[1].isVisible = true;
        container.widgets[1].actions[2].isVisible = false;
    };

    /* Resets labels, removing any formatting that might have been done by the validation. */
    this.resetLabels = function(container){
        container.widgets[0].label = container.widgets[0].label.endsWith("*") ? container.widgets[0].label.removeLastChar() : container.widgets[0].label;
        container.widgets[1].label = container.widgets[1].label.endsWith("*") ? container.widgets[1].label.removeLastChar() : container.widgets[1].label;
    }

    /* Checks if changes were made and asks if the user wishes to save them. */
    this.exitProfile = function(container){
        if ((container.widgets[0].dataSource.data[0].changed) && (container.widgets[0].template == "widget/form-view-edit.html") && (container.widgets[0].template == "widget/form-view-edit.html")) {
            ScreenService.confirmMessage(
                'Você deseja salvar as alterações antes de voltar?',
                'question',
                function(){
                    this.checkDetails(container);
                    ScreenService.openWindow('parentDashboard');
                }.bind(this),
                function(){
                    this.resetForms(container);
                    ScreenService.openWindow('parentDashboard');
                }.bind(this)
            );
        } else {
            this.resetForms(container);
            ScreenService.openWindow('parentDashboard');
        }
    };

    this.setCurrentConsumerTitle = function (container){
        this.getCurrentConsumerName().then(function (ConsumerName){
            container.label = ConsumerName;
        });
        this.getCurrentConsumerDetails(container);
    };

    this.getCurrentConsumerDetails = function (container, selectedWidget){
        var query = Query.build()
                         .where('CDCLIENTE').equals(selectedWidget.CDCLIENTE)
                         .where('CDCONSUMIDOR').equals(selectedWidget.CDCONSUMIDOR);

        ConsumersRepository.findOne(query).then(function(consumer){
            LoginRepository.findOne().then(function (previousConsumerData){
                //Setting current CDFILIAL so that recharge grid screen works perfectly
                consumer['CDFILIAL'] = previousConsumerData['CDFILIAL'];
                 LoginRepository.save(consumer).then(function(){
                     this.getDashboardDetails('dashboard');
                 }.bind(this));
            }.bind(this));
        }.bind(this));
    };

    this.setDashBoardTitle = function (container){
        this.getConsumerName().then(function (consumerName){
            container.label = consumerName;
        });
        this.getDashboardDetails(container);
    };

    this.getDashboardDetails = function (containerName){
        ScreenService.openWindow(containerName);
    };

    this.getConsumerName = function (){
        return LoginRepository.findOne().then(function (consumerData){
            templateManager.updateTemplate();
            return consumerData.NMCONSUMIDOR;
        });
    };

    /* Checks if a string ends with a certain character. */
    String.prototype.endsWith = function(suffix){
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
    };

    /* Removes the last character from a string. */
    String.prototype.removeLastChar = function(){
        return this.substring(0, this.length - 1);
    };

    this.handleMenus = function (){
        this.changeVisibilityGroup("menusClient", false);
        templateManager.updateTemplate();
    };

    this.notHandleMenus = function (){
        this.changeVisibilityGroup("menusClient", true);
        templateManager.updateTemplate();

    };

    this.changeVisibilityGroup = function (groupName, visibility) {
        var menuGroups = templateManager.project.groupMenu;

        menuGroups.forEach(function(menuGroup) {
            if (menuGroup.name == groupName) {
                menuGroup.isVisible = visibility;
                menuGroup.menus.forEach(function(menu) {
                    menu.isVisible = visibility;
                });
            }
        });
    };

    this.refreshBalance = function(container){
        LoginRepository.findOne().then(function (consumerData){
            this.setBalanceButton(container, consumerData, 'currentGold');
        }.bind(this));
    };

    this.setBalanceButton = function(container, consumerData, widgetName){
        container = templateManager.container;
        /* Sets the financial vision values. */

        if (container.getWidget("financialVision")){
            container.getWidget("financialVision").dataSource.data = consumerData.GRIDVALUES;
        }

        if (container.getWidget("financialVisionEn")){
            container.getWidget("financialVisionEn").dataSource.data = consumerData.GRIDVALUES;
        }

        if (container.getWidget("financialVisionEs")){
            container.getWidget("financialVisionEs").dataSource.data = consumerData.GRIDVALUES;
        }

        if (container.getWidget(widgetName)){
            container.getWidget(widgetName).dataSourceFilter[0].value = consumerData.CDCLIENTE;
            container.getWidget(widgetName).dataSourceFilter[1].value = consumerData.CDCONSUMIDOR;
            container.getWidget(widgetName).reload().then(function (saldos){
                currentGold = 0;
                if (saldos.dataset.BalanceRepository.length !== 0){
                    saldos.dataset.BalanceRepository.forEach(function (saldo){
                        valor = saldo.VRSALDCONFAM.moneyToFloat();
                        currentGold += valor;
                    });
                }
                container.getWidget(widgetName).notification = currentGold.toMoney();
            });
        }
    };

    this.setState = function(row, widget){
        setLocalVar('CDPAIS', row.CDPAIS);
        setLocalVar('SGESTADO', row.SGESTADO);
        CitiesRepository.clearAll().then(function (){
            var citiesField = widget.getField('NMMUNICIPIO');
            Utilities.clearField(citiesField);
            if (row.SGESTADO){
                citiesField.readOnly = false;
            }
            else{
                citiesField.readOnly = true;
            }
            citiesField.reload();
            templateManager.updateTemplate();
        });
    };

    this.setCities = function(row, widget){
        setLocalVar('CDMUNICIPIO', row.CDMUNICIPIO);
        NeighbourhoodsRepository.clearAll().then(function (){
            var neighbourhoodField = widget.getField('NMBAIRCONS');
            Utilities.clearField(neighbourhoodField);
            if (row.NMMUNICIPIO){
                neighbourhoodField.readOnly = false;
            }
            else{
                neighbourhoodField.readOnly = true;
            }
            neighbourhoodField.reload();
            templateManager.updateTemplate();
        });
    };

    this.setNeighbourhoods = function(field, row){
        if (getLocalVar('CDMUNICIPIO') == ""){
            NeighbourhoodsRepository.clearAll();
        }
        else {
            field.reload();
            templateManager.updateTemplate();
            field.setValue(row.NMBAIRRO);
        }
    };

    this.getNeighbourhoods = function(field) {
        field.reload();
    };

    this.configureWidget = function(widget) {
        widget.getAction('voltar').isVisible = true;
        widget.getAction('salvar').isVisible = false;

        if (widget.mode == "edit") {
            widget.getAction('voltar').isVisible = false;
            widget.getAction('salvar').isVisible = true;
        }

        setLocalVar('CDPAIS', widget.currentRow.CDPAIS);
        setLocalVar('SGESTADO', widget.currentRow.SGESTADO);
        setLocalVar('CDMUNICIPIO', widget.currentRow.CDMUNICIPIO);

    };

    this.configureMenu = function(container) {
        var menuGroups = templateManager.project.groupMenu;

        menuGroups[2].isVisible = false;
        menuGroups[1].menus[0].isVisible = false;
        menuGroups[1].menus[1].isVisible = false;
        menuGroups[1].menus[2].isVisible = false;
        menuGroups[1].menus[3].isVisible = false;
        menuGroups[1].menus[4].isVisible = false;
        menuGroups[2].menus[0].isVisible = false;
        menuGroups[2].menus[1].isVisible = false;
        menuGroups[2].menus[2].isVisible = false;

        templateManager.updateTemplate();

        LayoutRepo.findOne()
        .then(function(layout){
            if(layout.RECARREGACARTAO === 'S'){
                menuGroups[1].menus[0].isVisible = true;
            }
            if(layout.FALECONOSCO === 'S'){
                menuGroups[1].menus[2].isVisible = true;
            }
            if(layout.ATUALIZACADASTRO === 'S'){
                menuGroups[1].menus[3].isVisible = true;
            }
            if(layout.TROCASENHA === 'S'){
                menuGroups[1].menus[4].isVisible = true;
            }

            if (container.name == "dashboard"){
                if(layout.BLOQUEACARTAO === 'S' || layout.RESTRICAOALIMENTAR === 'S' || layout.RESTRICAOVALOR === 'S'){
                    menuGroups[2].isVisible = true;

                    if(layout.BLOQUEACARTAO === 'S'){
                        menuGroups[2].menus[0].isVisible = true;
                    }
                    if(layout.RESTRICAOALIMENTAR === 'S'){
                        menuGroups[2].menus[1].isVisible = true;
                    }
                    if(layout.RESTRICAOVALOR === 'S'){
                        menuGroups[2].menus[2].isVisible = true;
                    }
                }
            } else{
                menuGroups[2].isVisible = false;
            }
        });

        templateManager.updateTemplate();
    };

    this.configureWidgets = function(container){
        container.getWidget('currentGold').isVisible = false;
        container.getWidget('BlockCard').isVisible = false;
        container.getWidget('financialVision').isVisible = false;
        container.getWidget('financialVisionEn').isVisible = false;
        container.getWidget('financialVisionEs').isVisible = false;
        container.getWidget('RestrictAliment').isVisible = false;
        container.getWidget('RestrictValue').isVisible = false;
        container.getWidget('RestrictValueEn').isVisible = false;
        container.getWidget('RestrictValueEs').isVisible = false;
        container.getWidget('AutoRecharge').isVisible = false;
        container.getWidget('nutricionalReport').isVisible = false;

        templateManager.updateTemplate();

        var client = Utilities.getClientApp();

        var lang = window.lang;

        LayoutRepo.findOne()
        .then(function(layout){
            if(layout.CONSULTASALDO === 'S'){
                container.getWidget('currentGold').isVisible = true;
            }
            if(layout.CONSULTAEXTRATO === 'S'){
                if(lang == 'en_us'){
                    container.getWidget('financialVisionEn').isVisible = true;
                } else if(lang == 'es'){
                    container.getWidget('financialVisionEs').isVisible = true;
                } else{
                    container.getWidget('financialVision').isVisible = true;
                }
            }
            if(layout.BLOQUEACARTAO === 'S' && client !== 'grsa'){
                container.getWidget('BlockCard').isVisible = true;
            }
            if(layout.RESTRICAOALIMENTAR === 'S'  && client !== 'grsa'){
                container.getWidget('RestrictAliment').isVisible = true;
            }
            if(layout.RESTRICAOVALOR === 'S'  && client !== 'grsa'){
                if(lang == 'en_us'){
                    container.getWidget('RestrictValueEn').isVisible = true;
                } else if(lang == 'es'){
                    container.getWidget('RestrictValueEs').isVisible = true;
                } else{
                    container.getWidget('RestrictValue').isVisible = true;
                }
            }
            if(layout.RECARGAAUTOCARTAO === 'S'){
                container.getWidget('AutoRecharge').isVisible = true;
            }
            if(layout.IDUTILBOLNUTRI === 'S'){
                container.getWidget('nutricionalReport').isVisible = true;
            }
        });

        templateManager.updateTemplate();
    };

    this.checkEditOpen = function(){
        var openEdit = ProfileService.getOpenEdit();
        if(openEdit){
            var dadospessoaisWidget = templateManager.container.getWidget('dadospessoais');
            dadospessoaisWidget.getField('NRCPFRESPCON').readOnly = false;
            self.openEditAdress();
        }
    };

    this.toggleEmailValue = function(emailToggleField, emailValueField){
        if(emailToggleField.value() === 'Y'){
            emailValueField.isVisible = true;
        } else{
            emailValueField.isVisible = false;
        }
    };

    this.buildNotifEmailFields = function(widget){
        if(!ProfileService.getInitProfile()){
            ConsumersRepository.findAll().then(function(consumers){
                for (var i in consumers){
    
                    if(!!consumers[i]['CDCONSUMIDOR']){
                        var id = parseInt(i)+1;
        
                        var fieldJson = self.buildNewField(consumers[i], id);
                        var field = metaDataFactory.fieldFactory(fieldJson, widget);
                        widget.fields.push(field);
                        ++i;
                    }
                }
                
                self.buildBtnDelete(widget);
                
            });
            
            ProfileService.setInitProfile();
        }
    };
    
    this.buildBtnDelete = function(widget){
            var fieldJson = self.buildNewButton();
            var btnExcluir = metaDataFactory.fieldFactory(fieldJson, widget);
                widget.fields.push(btnExcluir);
    };
    this.showHideSonsField = function(widget, check){
        var fields = [];
        widget.fields.forEach(function(wField){
            if(wField.name.includes("notif-")){
                fields.push(wField);
            }
        });
        
        if(check.value() === 'N'){
            fields.forEach(function(field){
                field.isVisible = false;
            });
            templateManager.updateTemplate();
        } else if(check.value() === 'Y'){
            fields.forEach(function(field){
                field.isVisible = true;
                
            });
            templateManager.updateTemplate();
        }
    };

    this.buildNewField = function(consumer, id){
        var newField = 
        {
            "id": id,
            "CDCONSUMIDOR" : consumer['CDCONSUMIDOR'],
            "CDCLIENTE" : consumer['CDCLIENTE'],
            "name": "notif"+"-"+consumer['CDCONSUMIDOR'],
            "label": consumer['NMCONSUMIDOR']+":",
            "placeholder": null,
            "readOnly": false,
            "isVisible": true,
            "newLine": true,
            "defaultValue": null,
            "maxlength": 50,
            "template": "field/number.html",
            "dataSource": [],
            "events": [],
            "class": 6
        }

        return newField;
    };
    
        this.buildNewButton = function(){
        var newField = 
        {
            "id": 1,
            "name": "excluir",
            "label": "Solicitar exclusão de conta",
            "class": 12,
            "readOnly": false,
            "isVisible": true,
            "isVisibleForm": true,
            "isVisibleGrid": false,
            "newLine": false,
            "defaultValue": null,
            "template": "field/button.html",
            "events": [
                {
                    "id": 1,
                    "name": "FieldOnClick",
                    "code": "ProfileController.askProfileDeletion(templateManager.container.getActiveWidget());"
                }
            ]
        }
        return newField;
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('ProfileController', ProfileController);
});
